/*
 * bg_core.c
 * The core loop for bgrotd
 * bgrot project
 * $Fuller: myprograms/bgrot/server/bg_core.c,v 1.9 2003/03/24 16:28:19 fullermd Exp $
 */

#include <pthread.h>
#include <signal.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include <bgrot.h>
#include <bgrotd.h>

/* Globals */
extern IMGENT **cur_img;
extern IMGENT **nxt_img;
extern pthread_t img_thr;


/* Through the never */
void
bg_core(void)
{

	/* These need to be allocated */
	cur_img = malloc(sizeof(IMGENT *));
	nxt_img = malloc(sizeof(IMGENT *));
	*cur_img = NULL;
	*nxt_img = NULL;

	/* Seed */
	/* srandomdev(3) would be nice, but it's a FreeBSDism */
	srandom((unsigned)time(NULL));
	srand(random());

	/* Install signal handlers */
	signal(SIGTERM, emerg_exit);

	/* Launch on in */
	pthread_create(&img_thr, NULL, show_images_thr, NULL);

	/* Hang around doing nothing for a long, long time */
	while(1)
		pause();

	exit(1);
}
