/*
 * emerg_exit.c
 * Emergency exit functionality
 * bgrot project
 * $Fuller: myprograms/bgrot/server/util/emerg_exit.c,v 1.7 2003/03/26 11:50:33 fullermd Exp $
 */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <bgrot.h>
#include <bgrotd.h>

/* Suck globals */
extern pthread_t img_thr;
extern int debug;
extern BGROTD_CONF *runcf;
extern IMGENT **cur_img;
extern IMGENT **nxt_img;


/* Die, sucker */
void
emerg_exit(int dummy)
{

	pthread_cancel(img_thr);

	free_bgrotd_conf(runcf);
	free_imgent(*cur_img);
	free_imgent(*nxt_img);
	free(cur_img);
	free(nxt_img);

	/* Hack-ass making sure everything that needs done gets done */
	sleep(2);
	if(debug==1)
		fprintf(stderr, "Exiting from SIGTERM\n");
	exit(1);
}
